(** Environnements simples (listes d'associations) *)


(** Types des environnements qui associent ['a] aux variables *)
type 'a t = (Var.t * 'a) list

(** En cas d'chec *)
exception Failure of string

(** Ajouter une liaison.
     [add x v env] renvoie l'environnement qui est env plus une
     liaison de [x]  [v].

     {b Note :} si il existe dj une liaison de [x]  [w] dans env,
     alors elle est remplace par la nouvelle liaison.
*)
val add : string -> 'a -> 'a t -> 'a t

(** Rechercher la valeur associe  une variable.

     L'appel [find x env] renvoie la valeur [v] associe  [x] dans env.

     Si aucune valeur n'est associe  [x], l'exception [Failure x]
     est lance.
*)
val find : string -> 'a t -> 'a



