
(** Types des types *)

type t =
  | Nat        (** Type des entiers naturels [Nat] *)
  | Arrow of t * t (** Type des fonctions [A -> B] *)
  | Tvar of int (** Variable de type (TD 6) *)

open Format

let rec p_type chan = function
  | Nat -> fprintf chan "Nat"
  | Arrow (t1,t2) ->
      fprintf chan "%a -> %a" p_type_arg t1 p_type t2
  | Tvar x -> fprintf chan "t%i" x

and p_type_arg chan t = match t with
| Arrow _ -> fprintf chan "(%a)" p_type t
| _ -> p_type chan t

let print chan t =
  fprintf (formatter_of_out_channel chan) "%a@?" p_type t

let to_string t =
  ignore (flush_str_formatter ()) ;
  fprintf str_formatter "%a@?" p_type t ;
  flush_str_formatter ()
